<template>
    <header class="header">
        <div class="header__container">
            <div class="header__row">
                <div class="header__main">
                    <router-link to="/" class="header__logo">
                        <img src="../img/icons/logo.svg" alt="logo">
                    </router-link>
                    <div class="header__right">
                        <nav class="header__info">
                            <div class="header__auth">
                                <a href="#" class="show_popup" ref="popupButton" rel="popup1" v-if="!token">
                                    Log in
                                    <img src="../img/icons/user.svg" alt="Login">
                                </a>
                                <router-link :to="{name: 'Profile', params: { tab: 'orders', type: 'all'}}" v-else>
                                    <img src="../img/icons/user.svg" alt="Login">
                                    {{user.name}}
                                </router-link>
                            </div>
                        </nav>
                        <router-link :to="{name: 'Chatting'}">
                            <a class="messages">
                                <div class="messages__icon">
                                    <img src="../img/icons/chat.svg" alt="chat">
                                </div>
                            </a>
                        </router-link>
                        <router-link :to="{name: 'Profile', params: { tab: 'cart', type: 'all'}}" class="messages">
                            <div class="messages__icon">
                                <div class="counter">{{cartCount}}</div>
                                <svg xmlns="http://www.w3.org/2000/svg" width="35" height="34" viewBox="0 0 24 24" fill="none">
                                    <g id="Interface / Shopping_Cart_02">
                                        <path id="Vector" d="M3 3H3.26835C3.74213 3 3.97943 3 4.17267 3.08548C4.34304 3.16084 4.48871 3.28218 4.59375 3.43604C4.71269 3.61026 4.75564 3.8429 4.84137 4.30727L7.00004 16L17.4218 16C17.875 16 18.1023 16 18.29 15.9199C18.4559 15.8492 18.5989 15.7346 18.7051 15.5889C18.8252 15.4242 18.8761 15.2037 18.9777 14.7631L18.9785 14.76L20.5477 7.95996L20.5481 7.95854C20.7023 7.29016 20.7796 6.95515 20.6947 6.69238C20.6202 6.46182 20.4635 6.26634 20.2556 6.14192C20.0184 6 19.6758 6 18.9887 6H5.5M18 21C17.4477 21 17 20.5523 17 20C17 19.4477 17.4477 19 18 19C18.5523 19 19 19.4477 19 20C19 20.5523 18.5523 21 18 21ZM8 21C7.44772 21 7 20.5523 7 20C7 19.4477 7.44772 19 8 19C8.55228 19 9 19.4477 9 20C9 20.5523 8.55228 21 8 21Z" stroke="#ffffff" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"/>
                                    </g>
                                </svg>
                            </div>
                        </router-link>
                        <ul class="menu__list">
                            <div class="menu__close">
                                <img src="../img/icons/close-mob.svg" alt="close">
                            </div>
                            <router-link :to="{ name: 'Home', query: { selectedTab: 'Flights' }}"  class="menu__link" exact>
                                <img src="../img/icons/flights.svg" alt="flights">
                                Flights
                            </router-link>
                            <li>
                                <router-link :to="{ name: 'Home', query: { selectedTab: 'Hotels' }}"  class="menu__link" exact>
                                    <img src="../img/icons/hotels.svg" alt="hotels">
                                    Hotels
                                </router-link>
                            </li>
                            <li>
                                <router-link :to="{name: 'Chatting'}"  class="menu__link">
                                    <img src="../img/icons/travel_org.svg" alt="travel_org">
                                    Travel organization
                                </router-link>
                            </li>
                            <li>
                                <router-link :to="{name: 'Help'}"  class="menu__link">
                                    <img src="../img/icons/help.svg" alt="help">
                                    Help
                                </router-link>
                            </li>
                            <li>
                                <router-link :to="{name: 'About'}"  class="menu__link">
                                    <img src="../img/icons/about_us.svg" alt="about us">
                                    About us
                                </router-link>
                            </li>
                            <li>
                                <router-link :to="{name: 'Blog'}" class="menu__link">
                                    <img src="../img/icons/news.svg" alt="news">
                                    News
                                </router-link>
                            </li>
                            <li>
                                <router-link :to="{name: 'Contact'}" class="menu__link">
                                    <img src="../img/icons/contacts.svg" alt="contacts">
                                    Contacts
                                </router-link>
                            </li>
                        </ul>
                        <div class="header__menu">
                            <button class="icon-close">
                                <img src="../img/icons/close.svg" alt="close">
                            </button>
                            <button class="icon-menu">
                                <img src="../img/icons/menu.svg" alt="menu">
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </header>


    <router-view v-slot="{ Component }">
        <transition name="fade" mode="out-in">
            <component :is="Component" />
        </transition>
    </router-view>


    <footer class="footer">
        <div class="footer__container">
            <div class="footer__top">
                <div class="footer__menu">
                    <router-link :to="{ name: 'PrivacyPolicy'}">
                        <a class="footer__item">
                            Privacy Policy
                        </a>
                    </router-link>
                    <router-link :to="{ name: 'TermsAndConditions'}">
                        <a class="footer__item">
                            Terms & Conditions
                        </a>
                    </router-link>
                    <router-link :to="{ name: 'CancellationAndRefund'}">
                        <a class="footer__item">
                            Cancellations & Refunds
                        </a>
                    </router-link>
                    <router-link :to="{ name: 'Faq'}">
                        <a class="footer__item">
                            FAQ
                        </a>
                    </router-link>
                </div>
                <div class="footer__social footer__social--desc">
                    <a :href="this.information.instagram" class="footer__social--item">
                        <img src="../img/icons/instagram.svg" alt="instagram">
                    </a>
                    <a :href="this.information.facebook" class="footer__social--item">
                        <img src="../img/icons/facebook.svg" alt="facebook">
                    </a>
                    <a :href="this.information.twitter" class="footer__social--item">
                        <img src="../img/icons/twitter.svg" alt="twitter">
                    </a>
                    <a :href="this.information.linkedin" class="footer__social--item">
                        <img src="../img/icons/linkedin.svg" alt="linkedin">
                    </a>
                </div>
            </div>
            <div class="footer__bottom">
                <div class="footer__social footer__social--mob">
                    <a :href="this.information.instagram" class="footer__social--item">
                        <img src="../img/icons/instagram.svg" alt="instagram">
                    </a>
                    <a :href="this.information.facebook" class="footer__social--item">
                        <img src="../img/icons/facebook.svg" alt="facebook">
                    </a>
                    <a :href="this.information.twitter" class="footer__social--item">
                        <img src="../img/icons/twitter.svg" alt="twitter">
                    </a>
                    <a :href="this.information.linkedin" class="footer__social--item">
                        <img src="../img/icons/linkedin.svg" alt="linkedin">
                    </a>
                </div>
                <div class="footer__logo">
                    <a href="#">
                        <img src="../img/icons/logo-2.svg" alt="logo">
                    </a>
                </div>
                <div class="footer__links">
                    <a href="#">
                        {{this.information.site_name}}
                    </a>
                    <a href="mailto:info@travelcom.com">
                        <img src="../img/icons/mail.svg" alt="mail">
                        {{this.information.site_email}}
                    </a>
                    <a href="#">
                        <img src="../img/icons/location.svg" alt="location">
                        {{this.information.site_address}}
                    </a>
                </div>
            </div>
            <div class="footer__copyright">
                {{this.information.copyright}}
            </div>
        </div>
    </footer>

    <div class="menu-bar">
        <router-link :to="{ name: 'Home' }">
            <svg width="28" height="29" viewBox="0 0 28 29" fill="none" xmlns="http://www.w3.org/2000/svg">
                <path d="M3 14.5233C3 12.9984 3.28785 11.5654 3.86356 10.2242C4.43927 8.88306 5.21991 7.71642 6.20548 6.72432C7.19178 5.73222 8.3516 4.947 9.68493 4.36864C11.0183 3.79028 12.4429 3.50073 13.9589 3.5C16.4429 3.5 18.6438 4.23048 20.5616 5.69144C22.4795 7.1524 23.7763 9.02158 24.4521 11.299C24.5434 11.5562 24.4933 11.7951 24.3019 12.0155C24.1105 12.236 23.8683 12.3462 23.5753 12.3462C23.2648 12.3462 22.9774 12.2635 22.7129 12.0982C22.4484 11.9328 22.261 11.7032 22.1507 11.4092C21.7306 10.2702 21.0961 9.25969 20.2471 8.37782C19.3982 7.49596 18.398 6.82537 17.2466 6.36607V6.807C17.2466 7.41328 17.0321 7.93248 16.6033 8.36459C16.1744 8.79671 15.6583 9.0124 15.0548 9.01166H12.863V11.2163C12.863 11.5287 12.7578 11.7906 12.5474 12.0023C12.337 12.2139 12.0769 12.3194 11.7671 12.3187H9.57534V14.5233H10.6712C10.9817 14.5233 11.2422 14.6292 11.4526 14.8408C11.663 15.0524 11.7679 15.3141 11.7671 15.6257V17.8303H10.6712L5.41096 12.5391C5.35616 12.8698 5.30612 13.2005 5.26082 13.5312C5.21553 13.8619 5.19251 14.1926 5.19178 14.5233C5.19178 16.7647 5.92712 18.7214 7.39781 20.3933C8.86849 22.0651 10.7176 23.0297 12.9452 23.2869C13.2374 23.3236 13.4796 23.4478 13.6718 23.6595C13.8639 23.8711 13.9596 24.1327 13.9589 24.4443C13.9589 24.7567 13.8537 25.0186 13.6433 25.2303C13.4329 25.4419 13.1819 25.529 12.8904 25.4915C10.0959 25.216 7.74886 24.0401 5.84931 21.9641C3.94977 19.888 3 17.4078 3 14.5233ZM23.1644 24.2239L20.4247 21.468C20.0411 21.6885 19.6301 21.8722 19.1918 22.0192C18.7534 22.1662 18.2877 22.2397 17.7945 22.2397C16.4247 22.2397 15.2605 21.7576 14.3019 20.7934C13.3434 19.8292 12.8637 18.6578 12.863 17.2792C12.863 15.9012 13.3426 14.7302 14.3019 13.766C15.2612 12.8019 16.4254 12.3194 17.7945 12.3187C19.1644 12.3187 20.3289 12.8011 21.2882 13.766C22.2475 14.7309 22.7268 15.902 22.726 17.2792C22.726 17.7752 22.653 18.2437 22.5068 18.6846C22.3607 19.1256 22.1781 19.5389 21.9589 19.9248L24.6986 22.6806C24.8995 22.8827 25 23.1399 25 23.4522C25 23.7646 24.8995 24.0218 24.6986 24.2239C24.4977 24.426 24.242 24.527 23.9315 24.527C23.621 24.527 23.3653 24.426 23.1644 24.2239ZM17.7945 20.035C18.5616 20.035 19.21 19.7686 19.7397 19.2358C20.2694 18.703 20.5342 18.0508 20.5342 17.2792C20.5342 16.5075 20.2694 15.8553 19.7397 15.3225C19.21 14.7897 18.5616 14.5233 17.7945 14.5233C17.0274 14.5233 16.379 14.7897 15.8493 15.3225C15.3196 15.8553 15.0548 16.5075 15.0548 17.2792C15.0548 18.0508 15.3196 18.703 15.8493 19.2358C16.379 19.7686 17.0274 20.035 17.7945 20.035Z" fill="#9B9B9A"/>
            </svg>
            Travel
        </router-link>

        <router-link :to="{ name: 'Home', query: { selectedTab: 'Hotels' } }">
            <svg width="29" height="29" viewBox="0 0 29 29" fill="none" xmlns="http://www.w3.org/2000/svg">
                <path d="M4.5 5.6875C4.5 5.03066 5.03066 4.5 5.6875 4.5H22.3125C22.9693 4.5 23.5 5.03066 23.5 5.6875C23.5 6.34434 22.9693 6.875 22.3125 6.875V21.125C22.9693 21.125 23.5 21.6557 23.5 22.3125C23.5 22.9693 22.9693 23.5 22.3125 23.5H15.7812V21.7188C15.7812 20.7354 14.9834 19.9375 14 19.9375C13.0166 19.9375 12.2188 20.7354 12.2188 21.7188V23.5H5.6875C5.03066 23.5 4.5 22.9693 4.5 22.3125C4.5 21.6557 5.03066 21.125 5.6875 21.125V6.875C5.03066 6.875 4.5 6.34434 4.5 5.6875ZM8.0625 8.65625V9.84375C8.0625 10.1703 8.32969 10.4375 8.65625 10.4375H9.84375C10.1703 10.4375 10.4375 10.1703 10.4375 9.84375V8.65625C10.4375 8.32969 10.1703 8.0625 9.84375 8.0625H8.65625C8.32969 8.0625 8.0625 8.32969 8.0625 8.65625ZM13.4062 8.0625C13.0797 8.0625 12.8125 8.32969 12.8125 8.65625V9.84375C12.8125 10.1703 13.0797 10.4375 13.4062 10.4375H14.5938C14.9203 10.4375 15.1875 10.1703 15.1875 9.84375V8.65625C15.1875 8.32969 14.9203 8.0625 14.5938 8.0625H13.4062ZM17.5625 8.65625V9.84375C17.5625 10.1703 17.8297 10.4375 18.1562 10.4375H19.3438C19.6703 10.4375 19.9375 10.1703 19.9375 9.84375V8.65625C19.9375 8.32969 19.6703 8.0625 19.3438 8.0625H18.1562C17.8297 8.0625 17.5625 8.32969 17.5625 8.65625ZM8.65625 11.625C8.32969 11.625 8.0625 11.8922 8.0625 12.2188V13.4062C8.0625 13.7328 8.32969 14 8.65625 14H9.84375C10.1703 14 10.4375 13.7328 10.4375 13.4062V12.2188C10.4375 11.8922 10.1703 11.625 9.84375 11.625H8.65625ZM12.8125 12.2188V13.4062C12.8125 13.7328 13.0797 14 13.4062 14H14.5938C14.9203 14 15.1875 13.7328 15.1875 13.4062V12.2188C15.1875 11.8922 14.9203 11.625 14.5938 11.625H13.4062C13.0797 11.625 12.8125 11.8922 12.8125 12.2188ZM18.1562 11.625C17.8297 11.625 17.5625 11.8922 17.5625 12.2188V13.4062C17.5625 13.7328 17.8297 14 18.1562 14H19.3438C19.6703 14 19.9375 13.7328 19.9375 13.4062V12.2188C19.9375 11.8922 19.6703 11.625 19.3438 11.625H18.1562ZM16.6719 18.75C17.1654 18.75 17.5736 18.3455 17.4512 17.8668C17.0578 16.3268 15.6625 15.1875 14 15.1875C12.3375 15.1875 10.9385 16.3268 10.5488 17.8668C10.4264 18.3418 10.8383 18.75 11.3281 18.75H16.6719Z" fill="#9B9B9A"/>
            </svg>
            Hotels
        </router-link>

        <router-link :to="{ name: 'Home', query: { selectedTab: 'Flights' } }">
            <svg width="29" height="29" viewBox="0 0 29 29" fill="none" xmlns="http://www.w3.org/2000/svg">
                <path d="M8.5746 20.4195L4.90172 18.408L6.10689 17.2011L8.97633 17.6034L13.4527 13.1207L4.5 8.23563L6.10689 6.62644L17.0681 9.44253L21.5732 4.98851C21.8984 4.66284 22.3051 4.5 22.7933 4.5C23.2814 4.5 23.6878 4.66284 24.0122 4.98851C24.3374 5.31418 24.5 5.72146 24.5 6.21034C24.5 6.69923 24.3374 7.10613 24.0122 7.43103L19.5359 11.9138L22.3479 22.8908L20.741 24.5L15.863 15.5345L11.3867 20.0172L11.7884 22.8908L10.5832 24.0977L8.5746 20.4195Z" fill="black"/>
                <path d="M8.5746 20.4195L4.90172 18.408L6.10689 17.2011L8.97633 17.6034L13.4527 13.1207L4.5 8.23563L6.10689 6.62644L17.0681 9.44253L21.5732 4.98851C21.8984 4.66284 22.3051 4.5 22.7933 4.5C23.2814 4.5 23.6878 4.66284 24.0122 4.98851C24.3374 5.31418 24.5 5.72146 24.5 6.21034C24.5 6.69923 24.3374 7.10613 24.0122 7.43103L19.5359 11.9138L22.3479 22.8908L20.741 24.5L15.863 15.5345L11.3867 20.0172L11.7884 22.8908L10.5832 24.0977L8.5746 20.4195Z" fill="#9B9B9A"/>
            </svg>
            Flights
        </router-link>

        <router-link :to="{name: 'Chatting'}">
            <svg width="28" height="29" viewBox="0 0 28 29" fill="none" xmlns="http://www.w3.org/2000/svg">
                <path d="M8.96 17.1889V9.61111H4.4C3.08 9.61111 2 10.7111 2 12.0556V19.3889C2 20.7333 3.08 21.8333 4.4 21.8333H5.6V25.5L9.2 21.8333H15.2C16.52 21.8333 17.6 20.7333 17.6 19.3889V17.1644C17.5211 17.1817 17.4407 17.1903 17.36 17.1901H8.96V17.1889ZM23.6 3.5H12.8C11.48 3.5 10.4 4.6 10.4 5.94444V15.7222H18.8L22.4 19.3889V15.7222H23.6C24.92 15.7222 26 14.6234 26 13.2778V5.94444C26 4.6 24.92 3.5 23.6 3.5Z" fill="#9B9B9A"/>
            </svg>
            Chat
        </router-link>

        <router-link :to="{name: 'Profile', params: { tab: 'orders', type: 'all' }}">
            <svg width="28" height="29" viewBox="0 0 28 29" fill="none" xmlns="http://www.w3.org/2000/svg">
                <path d="M13.5 6.5C12.61 6.5 11.74 6.76392 10.9999 7.25839C10.2599 7.75285 9.68314 8.45566 9.34254 9.27792C9.00195 10.1002 8.91283 11.005 9.08647 11.8779C9.2601 12.7508 9.68869 13.5526 10.318 14.182C10.9474 14.8113 11.7492 15.2399 12.6221 15.4135C13.495 15.5872 14.3998 15.498 15.2221 15.1575C16.0443 14.8169 16.7471 14.2401 17.2416 13.5001C17.7361 12.76 18 11.89 18 11C18 9.80652 17.5259 8.66193 16.682 7.81802C15.8381 6.97411 14.6935 6.5 13.5 6.5Z" fill="#9B9B9A"/>
                <path d="M13.5 1.5C11.0277 1.5 8.61099 2.23311 6.55538 3.60663C4.49976 4.98015 2.89761 6.93238 1.95151 9.21646C1.00542 11.5005 0.757874 14.0139 1.24019 16.4386C1.7225 18.8634 2.91301 21.0907 4.66117 22.8388C6.40933 24.587 8.63661 25.7775 11.0614 26.2598C13.4861 26.7421 15.9995 26.4946 18.2835 25.5485C20.5676 24.6024 22.5199 23.0002 23.8934 20.9446C25.2669 18.889 26 16.4723 26 14C25.9962 10.686 24.678 7.50873 22.3347 5.16534C19.9913 2.82196 16.814 1.50378 13.5 1.5ZM20.6366 21.9696C20.6188 20.7984 20.1415 19.6809 19.3076 18.8582C18.4737 18.0355 17.35 17.5734 16.1786 17.5714H10.8214C9.65017 17.5736 8.52664 18.0359 7.69294 18.8586C6.85924 19.6812 6.38208 20.7985 6.36429 21.9696C4.74515 20.5239 3.60334 18.6204 3.09004 16.5113C2.57674 14.4022 2.71617 12.1869 3.48986 10.1588C4.26356 8.13069 5.63502 6.38542 7.42266 5.15408C9.21029 3.92274 11.3298 3.26342 13.5004 3.26342C15.6711 3.26342 17.7906 3.92274 19.5782 5.15408C21.3659 6.38542 22.7373 8.13069 23.511 10.1588C24.2847 12.1869 24.4242 14.4022 23.9109 16.5113C23.3976 18.6204 22.2557 20.5239 20.6366 21.9696Z" fill="#9B9B9A"/>
            </svg>
            Profile
        </router-link>
    </div>
    <div class="overlay_popup"></div>
    <div class="popup" id="popup1">
        <p class="popup__title">Entrance</p>
        <h3>{{ hasError.login }}</h3>
        <form class="popup__form">
            <div class="popup__form--input">
                <div class="popup__form--icon">
                    <img src="../img/icons/email-alt.svg" alt="mail">
                </div>
                <input type="email" v-model="email" placeholder="Email">
            </div>
            <div class="popup__form--input">
                <div class="popup__form--icon">
                    <img src="../img/icons/password.svg" alt="password">
                </div>
                <input type="password" v-model="password" placeholder="Password">
            </div>
            <div class="popup__form--checkbox">
                <input type="checkbox" id="remember" name="remember" class="popup__form--input" checked="">
                <label for="remember" class="popup__form--label">Remember me</label>
            </div>
            <div class="popup__small">
                Don't you have an account? <a href="#" class="show_popup" rel="popup2">Register.</a>
            </div>
            <a class="popup__btn btn" @click="login">
                Log in
            </a>
        </form>
    </div>
    <div class="popup" id="popup2">
        <p class="popup__title">Registration</p>
        <h3>{{ hasError.registr }}</h3>
        <div class="popup__form">
            <div class="popup__form--input">
                <div class="popup__form--icon">
                    <img src="../img/icons/name.svg" alt="user">
                </div>
                <input type="text" v-model="name" placeholder="Name">
            </div>
            <div class="popup__form--input">
                <div class="popup__form--icon">
                    <img src="../img/icons/email-alt.svg" alt="mail">
                </div>
                <input type="email" v-model="email"  placeholder="Email">
            </div>
            <div class="popup__form--input">
                <div class="popup__form--icon">
                    <img src="../img/icons/phone-bold.svg" alt="Phone">
                </div>
                <input type="text" v-model="phone"  placeholder="Phone number">
            </div>
            <div class="popup__form--input">
                <div class="popup__form--icon">
                    <img src="../img/icons/password.svg" alt="password">
                </div>
                <input type="password" v-model="password"  placeholder="Password">
            </div>
            <div class="popup__form--checkbox">
                <input type="checkbox" id="remember2" name="remember" class="popup__form--input" checked="">
                <label for="remember2" class="popup__form--label">Remember me</label>
            </div>
            <div class="popup__small">
                Already have an account? <a href="#"class="show_popup show_popup2" rel="popup1">Log in.</a>
            </div>
            <button class="popup__btn btn" @click="register">
                Registr
            </button>
        </div>
    </div>
</template>

<script>
import axios from "axios";

export default {
    data() {
        return {
            token: localStorage.access_token,
            user: '',
            email: '',
            phone: '',
            cartCount: 0,
            name: '',
            password: '',
            information: [],
            hasError: {
                login: '',
                registr: '',
            }
        }
    },
    mounted() {
        if(localStorage.user) {
            this.user = JSON.parse(localStorage.user)
        }
        this.getInfo()
        this.getCart()
    },
    methods: {
        register() {
            axios.post('/api/auth/register', {
                email: this.email,
                phone: this.phone,
                name: this.name,
                password: this.password,
            }).then(({data}) => {
                if (data.success) {
                    localStorage.access_token = data.success.token
                    localStorage.user = JSON.stringify(data.user)
                    window.location.reload()
                }
            }).catch(error => {
                this.hasError.registr = error.response.data.message;
            });
        },
        login() {
            axios.post('/api/auth/login', {
                email: this.email,
                password: this.password,
            }).then(({data}) => {
                if(data.success) {
                    localStorage.access_token = data.success.token
                    localStorage.user = JSON.stringify(data.user)
                  //window.location.reload()
                }
            }).catch(error => {
                this.hasError.login = error.response.data.message;
            });
        },
        getInfo() {
            axios.get('/api/information/get', ).then(({data}) => {
               this.information = data
            })
        },
        getCart() {
            if (this.user) {
                axios.get('/api/cart/my').then(({data}) => {
                    this.cartCount = data.length
                })
            }
        },
        logout() {
            localStorage.clear()
            this.$router.push({ name: 'Home' }).then(() => {
                window.location.reload();
            });
        }
    }
}
</script>

<style scoped>
.fade-enter-active,
.fade-leave-active {
    transition: opacity 0.5s ease;
}

.fade-enter-from,
.fade-leave-to {
    opacity: 0;
}
.counter {
    position: absolute;
    background-color: red;
    width: 16px;
    height: 16px;
    font-size: 12px;
    text-align: center;
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 50%;
}
</style>
